#!/usr/bin/env python
# Plot a graph of Data which is comming in on the fly
# uses pylab
# Author: Norbert Feurle
# Date: 12.1.2012
# License: if you get any profit from this then please share it with me
import pylab
from pylab import *

# UDP related code

import socket
import struct
import binascii
UDP_IP = "169.254.84.247"
UDP_PORT = 25000

sock = socket.socket(socket.AF_INET, # Internet                       
         socket.SOCK_DGRAM) # UDP
 
p = struct.Struct('d')
sock.bind((UDP_IP, UDP_PORT))


xAchse=pylab.arange(0,100,1)
yAchse=pylab.array([0]*100)

fig = pylab.figure(1)
ax = fig.add_subplot(111)
ax.grid(True)
ax.set_title("UDP data Plot")   
ax.set_xlabel("Time")
ax.set_ylabel("Amplitude")
ax.axis([0,100,-20.0,20.0])
line1=ax.plot(xAchse,yAchse,'-')

manager = pylab.get_current_fig_manager()

values=[]
values = [0 for x in range(100)]


while True:
    data, addr = sock.recvfrom(8) # buffer size is 1024 bytes
    R = binascii.hexlify(data)
    
    R1 = binascii.unhexlify(R)
    RU = p.unpack(R1)
    RU2 = int(RU[0])
    values.append(RU2)
    
    CurrentXAxis=pylab.arange(len(values)-100,len(values),1)
    line1[0].set_data(CurrentXAxis,pylab.array(values[-100:]))
    ax.axis([CurrentXAxis.min(),CurrentXAxis.max(),0,260])
    manager.canvas.draw()
    manager.show()


pylab.show()